"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const request = require("request");
const Debug = require("debug");
const debug = Debug("apifs:circuit");
class CircuitClient {
    // TODO: circuit breaker missing
    constructor(gateway) {
        this.gateway = gateway;
        if (process.env.IGNORE_SSL) {
            this.request = request.defaults({
                strictSSL: false,
                rejectUnauthorized: false,
            });
        }
        else {
            this.request = request;
        }
    }
    call(options) {
        const startT = Date.now();
        options.json = true;
        debug(`Calling ${options.method} ${options.url}`);
        return new Promise((resolve, reject) => {
            this.request(options, (error, response, body) => {
                if (error) {
                    return reject(error);
                }
                const difference = Date.now() - startT;
                debug(`Resolved call to ${options.method} ${options.url} after ${difference} ms.`);
                resolve({
                    status: response.statusCode,
                    headers: response.headers,
                    body,
                });
            });
        });
    }
}
exports.default = CircuitClient;
