import { GatewayConfig } from "./interfaces/GatewayConfig";
import { FunctionsConfig } from "./interfaces/FunctionsConfig";
import CircuitClient from "./CircuitClient";
export declare const AUTH_TYPES: {
    NONE: string;
    USER: string;
    MACHINE: string;
    USER_AND_MACHINE: string;
};
export declare const REQUEST_METHODS: {
    GET: string;
    POST: string;
    PUT: string;
    PATCH: string;
    DELETE: string;
    HEAD: string;
    OPTIONS: string;
};
export declare const CORRELATION_ID_HEADER = "correlation-id";
export declare const DEFAULT_TIMEOUT = 1500;
export declare const SECRET_HEADER = "apifs-secret";
export declare const BAD_PROXY_HEADERS: string[];
export default class Gateway {
    readonly gatewayConfig: GatewayConfig;
    readonly functionsConfig: FunctionsConfig;
    readonly circuitClient: CircuitClient;
    private readonly app;
    private server;
    private requestHandler;
    private alive;
    private ready;
    constructor(gatewayConfig: GatewayConfig, functionsConfig: FunctionsConfig);
    isAlive(): boolean;
    isReady(): boolean;
    getHealthStatus(): [number, any];
    init(): Gateway;
    run(): Promise<Gateway>;
    close(): Promise<Gateway>;
}
//# sourceMappingURL=Gateway.d.ts.map